#include "mainwindow.h"
#include "serial.hpp"

#include "settings.hpp"
#include "log.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)

{
    setupUi(this);
    connect(actionSettings_3,SIGNAL(triggered()), this, SLOT(openSettingsWindow()));

    settings_value = new SettingsValue(13,0,0);

}

MainWindow::~MainWindow()
{

}

void MainWindow::on_btnConnect_clicked()
{
    QString path = "/dev/ttyUSB0";
    if(btnConnect->text() == "connect"){
        btnConnect->setText("disconnect");
        interface = new serial(settings_value,path);
        interface->openSerialPort();
    }
    else{
        btnConnect->setText("connect");
        interface->closeSerialPort();
        delete interface;
    }


}

void MainWindow::openSettingsWindow(){
    new_settings_window = new Settings(this,settings_value);
    new_settings_window->show();
}

void MainWindow::closeSettingsWindow(){
    delete new_settings_window;
}

void MainWindow::on_btnSenden_clicked()
{
    interface->writeSerialPort(txtSenden->text());
}
