/*
 * serial.cpp
 *
 *  Created on: 04.05.2013
 *      Author: martin
 */

#include <termios.h>	/* POSIX terminal control definitions */
#include <fcntl.h>		/* File control definitions */
#include <stdio.h>
#include <errno.h>		/*Error number definitions*/
#include <string.h>		// strlen
/* write(), read() */
#include <unistd.h>  /* UNIX standard function definitions */

#include <stdlib.h>
// #include <sys/types.h>
// #include <sys/stat.h>

#include <QString>
#include "settings.hpp"
#include "serial.hpp"

#include "log.h" // Fehlerausgabe
#include <QString>
#include <QByteArray>




serial::serial(SettingsValue *Psettings_value, QString &path):settings_value(Psettings_value),path(path){

    QString string_baudrate2;
    string_baudrate2 = settings_value->get_string_current_baudrate();
    baudrate = string_baudrate2.toUInt();
    bits = settings_value->get_current_bits_byte(); // stimpt noch nicht
    parity = settings_value->get_current_parity();
	fd = 0;
}

bool serial::openSerialPort(){


    Log *error = new Log();

    error->listLog->addItem("Test");

    //converts QString path to char[] path
    QString path2 = serial::get_path();
    //int lenght2 = path2.size();
    //wchar_t *wc_path = new wchar_t[lenght2*2];
    //char *path = NULL;
    QByteArray path3;

    //path2.toWCharArray(wc_path);
    path3 = path2.toAscii();
    //unsigned int lenght = sizeof(wc_path);
    //if(lenght != wcstombs(path,wc_path,lenght)){
    //output Error!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //    return false;
    //}


	struct termios term_attr;
    unsigned int speed;
    fd = open(path3,O_RDWR | O_NOCTTY | O_NDELAY);
	if(fd == -1){
		perror("open_port: Unable to open /dev/ttyUSB0 - ");



		return false;
	}
	else{
		printf("open_port: Abled to open /dev/ttyUSB0");

		fcntl(fd,F_SETFL,0);

	}

	if(tcgetattr(fd, &term_attr) != 0){
		perror("terminal: tcgetattr() failed");

		return false;
	}

	switch(baudrate){
	case 50:		speed = 00000001; break;
	case 75:		speed = 00000002; break;
	case 110:		speed = 00000003; break;
	case 134:		speed = 00000004; break;
	case 150:		speed = 00000005; break;
	case 200:		speed = 00000006; break;
	case 300:		speed = 00000007; break;
	case 600:		speed = 00000010; break;
	case 1200:		speed = 00000011; break;
	case 1800:		speed = 00000012; break;
	case 2400:		speed = 00000013; break;
	case 4800:		speed = 00000014; break;
	case 9600:		speed = 00000015; break;
	case 19200:		speed = 00000016; break;
	case 38400:		speed = 00000017; break;
    default:    printf("Illegally Baudrate.");

                return false;
                break;
	}

	// Die Parameter die verwendet werden um über die serielle zu
	// kommunizieren
    //term_attr.c_ispeed

	term_attr.c_cflag = speed | CS8 | CRTSCTS | CLOCAL;
	term_attr.c_iflag = 0;
	term_attr.c_oflag = OPOST | ONLCR;
	term_attr.c_lflag = 0;

	// term_attr.c_cflag |= PARENB;	// PArity einschalten
	// term_attr.c_cflag |= PARODD;	/// odd parity
	// term_attr.c_cflag &= ~CSTOPB;	//1 Stoppbit
	// term_attr.c_cflag &= ~CSIZE;	// Select the character size bits
	// term_attr.c_cflag |= CS8;		// 8 DataBITS


	if (tcsetattr(fd, TCSAFLUSH, &term_attr) != 0)
	    perror("terminal: tcsetattr() failed");

	return true;
}

bool serial::closeSerialPort(){

    if(close(this->fd) != -1)
        return true;

    return false;
}

bool serial::writeSerialPort(QString send_string){

    QByteArray write_string = send_string.toUtf8();
	int str_len;
    //char c = 'A';


    str_len = write_string.size();
	write_string[str_len] = 0x0d; // stick a <CR> after the command
	write_string[str_len+1] = 0x0d; // stick a <CR> after the command

	if(write(fd, write_string, strlen(write_string)) < 0){
		fputs("write failed!\n",stderr);

		return false;
	}

	return true;
}

bool serial::readSerialPort(char *read_string){

	//gibt anzahl gelesener Bytes zurück
	if(read(fd, read_string, 1) <0){
		fputs("read failed!\n",stderr);

	}

	return true;
}

void serial::delay(long time){
	usleep(time);
}

