#include <QList>
#include "settings.hpp"
#include "mainwindow.h" // MainWindow deklaration



//class SettingsValue;


Settings::Settings(MainWindow* PMainWindow,SettingsValue* PSettingsValue,  QDialog *parent):
    my_main_window(PMainWindow),
    QDialog(parent),
    my_settings_value(PSettingsValue)

{
    setupUi(this);

        comboBaudrate->addItems(my_settings_value->get_baudrate());
        comboBits->addItems(my_settings_value->get_bits_byte());
        comboParity->addItems(my_settings_value->get_parity());

        comboBaudrate->setCurrentIndex(my_settings_value->get_old_baudrate());
        comboBits->setCurrentIndex(my_settings_value->get_old_bits_byte());
        comboParity->setCurrentIndex(my_settings_value->get_old_parity());
}


void Settings::on_buttonBox_accepted()
{
    my_settings_value->set_old_baudrate(my_settings_value->get_current_baudrate());
    my_settings_value->set_old_bits_byte(my_settings_value->get_current_bits_byte());
    my_settings_value->set_old_parity(my_settings_value->get_current_parity());
    my_main_window->closeSettingsWindow();
}

void Settings::on_buttonBox_rejected()
{
    my_settings_value->set_current_baudrate(my_settings_value->get_old_baudrate());
    my_settings_value->set_current_bits_byte(my_settings_value->get_old_bits_byte());
    my_settings_value->set_current_parity(my_settings_value->get_old_parity());
    //my_settings_value->current_baudrate = my_settings_value->old_baudrate;
    //my_settings_value->current_bits_byte = my_settings_value->old_bits_byte;
    //my_settings_value->current_parity = my_settings_value->old_parity;
    my_main_window->closeSettingsWindow();

}

void Settings::on_comboParity_currentIndexChanged(int index)
{
    my_settings_value->set_current_parity(comboParity->currentIndex());
    //my_settings_value->current_parity = comboParity->currentIndex();
}

void Settings::on_comboBaudrate_currentIndexChanged(int index)
{
    my_settings_value->set_current_baudrate(comboBaudrate->currentIndex());
    //my_settings_value->current_baudrate = comboBaudrate->currentIndex();
    my_settings_value->set_string_current_baudrate(comboBaudrate->currentText());
}

void Settings::on_comboBits_currentIndexChanged(int index)
{
    my_settings_value->set_current_bits_byte(comboBits->currentIndex());
    //my_settings_value->current_bits_byte = comboBits->currentIndex();
}


void Settings::getString_current_baudrate(){
    my_settings_value->set_string_current_baudrate(comboBaudrate->currentText());
    }

SettingsValue::SettingsValue(int old_baudrate, int old_bits_byte, int old_parity):
    old_baudrate(old_baudrate), old_bits_byte(old_bits_byte), old_parity(old_parity)
{
    //add Values to QStringList baudrate
    baudrate <<"50" << "75" << "110" << "134" << "150" << "200" << "300"
            << "600" << "1200" << "1800" << "2400" << "4800" << "9600"
            << "19200" << "38400";

    //add Values to QStringList parity
    parity << "No" << "Yes";

    //add Values to QStringList bits_byte
    bits_byte << "8" << "9";

    current_bits_byte = 0;
    current_parity = 0;

    string_current_baudrate = "19200";
}



