#ifndef SETTINGS_HPP
#define SETTINGS_HPP

#include "ui_settings.h"
class MainWindow;
class SettingsValue;

class Settings: public QDialog, public Ui::Dialog
{
    Q_OBJECT

public:
    Settings(MainWindow *PMainWindow, SettingsValue *PSettingsValue, QDialog *parent = 0);
    void getString_current_baudrate();


private slots:
    void on_buttonBox_accepted();

    void on_comboParity_currentIndexChanged(int index);

    void on_buttonBox_rejected();

    void on_comboBaudrate_currentIndexChanged(int index);

    void on_comboBits_currentIndexChanged(int index);

private:
    MainWindow *my_main_window = NULL;
    SettingsValue *my_settings_value = NULL;

};

class SettingsValue
{
public:
    //Konstructor
    SettingsValue(int old_baudrate,int old_bits_byte, int old_parity);

    QStringList get_baudrate(void){return baudrate;}
    QStringList get_parity(void){return parity;}
    QStringList get_bits_byte(void){return bits_byte;}

    QString defaultBaudrate(){ return "19200";}
    QString defaultParity() {return "No"; }
    QString defaultBitsByte(){return "8";}

    void set_old_baudrate(int index){old_baudrate=index;}
    void set_old_parity(int index){old_parity=index;}
    void set_old_bits_byte(int index){old_bits_byte=index;}
    void set_current_baudrate(int index){current_baudrate=index;}
    void set_current_parity(int index){current_parity=index;}
    void set_current_bits_byte(int index){current_bits_byte=index;}

    int get_old_baudrate(){return old_baudrate;}
    int get_old_bits_byte(){return old_bits_byte;}
    int get_old_parity(){return old_parity;}
    int get_current_baudrate(){return current_baudrate;}
    int get_current_bits_byte(){return current_bits_byte;}
    int get_current_parity(){return current_parity;}
    void set_string_current_baudrate(QString string_baudrate){string_current_baudrate = string_baudrate;}
    QString get_string_current_baudrate(void){return string_current_baudrate;}




private:
    QStringList baudrate;
    QStringList parity;
    QStringList bits_byte;
    int current_baudrate;
    int current_parity;
    int current_bits_byte;
    int old_baudrate;
    int old_parity;
    int old_bits_byte;
    QString string_current_baudrate;

};



#endif // SETTINGS_HPP

